searchNodes=[{"doc":"Documentation forthcoming.","ref":"AshPolicyAuthorizer.html","title":"AshPolicyAuthorizer","type":"module"},{"doc":"","ref":"AshPolicyAuthorizer.html#access_type/1","title":"AshPolicyAuthorizer.access_type/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.html#describe_resource/1","title":"AshPolicyAuthorizer.describe_resource/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.html#policies/1","title":"AshPolicyAuthorizer.policies/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.html#t:prepare_instruction/0","title":"AshPolicyAuthorizer.prepare_instruction/0","type":"type"},{"doc":"","ref":"AshPolicyAuthorizer.html#t:request/0","title":"AshPolicyAuthorizer.request/0","type":"type"},{"doc":"","ref":"AshPolicyAuthorizer.html#t:side_load/0","title":"AshPolicyAuthorizer.side_load/0","type":"type"},{"doc":"","ref":"AshPolicyAuthorizer.Authorizer.Policy.html","title":"AshPolicyAuthorizer.Authorizer.Policy","type":"module"},{"doc":"A policy has a name, a condition, and a list of checks.Checks apply logically in the order they are specified, from top to bottom. If no check explicitly authorizes the request, then the request is forbidden. This means that, if you want to &quot;blacklist&quot; instead of &quot;whitelist&quot;, you likely want to add an authorize_if always() at the bottom of your policy, like so:policy action_type(:read) do forbid_if not_logged_in() forbid_if user_is_denylisted() forbid_if user_is_in_denylisted_group() authorize_if always() endIf the policy should always run, use the always() check, like so:policy always() do ... endArguments:condition - A check or list of checks that must be true in order for this policy to apply.If the policy does not apply, it is not run, and some other policy will need to authorize the request. If no policies apply, the request is forbidden. If multiple policies apply, they must each authorize the request.Options:name - A short name or description for the policy, used when explaining authorization results","ref":"AshPolicyAuthorizer.Authorizer.Policy.html#policy/2","title":"AshPolicyAuthorizer.Authorizer.Policy.policy/2","type":"macro"},{"doc":"","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeIf.html","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeIf","type":"module"},{"doc":"If the check is true, the request is authorized, otherwise run remaining checks.Examplesauthorize_if logged_in()authorize_if actor_attribute_matches_record(:group, :group)Arguments:check - A check is a tuple of {module, keyword}.The module must implement the AshPolicyAuthorizer.Check behaviour. Generally, you won't be passing {module, opts}, but will use one of the provided functions that return that, like always() or actor_attribute_matches_record(:foo, :bar). To make custom ones define a module that implements the AshPolicyAuthorizer.Check behaviour, put a convenience function in that module that returns {module, opts}, and import that into your resource.defmodule MyResource do use Ash.Resource, authorizers: [AshPolicyAuthorizer.Authorizer] import MyCustomCheck policies do ... policy do authorize_if my_custom_check(:foo) end end endOptions:name - false A short name or description for the check, used when explaining authorization results","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeIf.html#authorize_if/2","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeIf.authorize_if/2","type":"macro"},{"doc":"","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeUnless.html","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeUnless","type":"module"},{"doc":"If the check is false, the request is authorized, otherwise run remaining checks.Examplesauthorize_unless not_logged_in()authorize_unless actor_attribute_matches_record(:group, :blacklisted_groups)Arguments:check - A check is a tuple of {module, keyword}.The module must implement the AshPolicyAuthorizer.Check behaviour. Generally, you won't be passing {module, opts}, but will use one of the provided functions that return that, like always() or actor_attribute_matches_record(:foo, :bar). To make custom ones define a module that implements the AshPolicyAuthorizer.Check behaviour, put a convenience function in that module that returns {module, opts}, and import that into your resource.defmodule MyResource do use Ash.Resource, authorizers: [AshPolicyAuthorizer.Authorizer] import MyCustomCheck policies do ... policy do authorize_if my_custom_check(:foo) end end endOptions:name - false A short name or description for the check, used when explaining authorization results","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeUnless.html#authorize_unless/2","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.AuthorizeUnless.authorize_unless/2","type":"macro"},{"doc":"","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidIf.html","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidIf","type":"module"},{"doc":"If the check is true, the request is forbidden, otherwise run remaining checks.Examplesforbid_if not_logged_in()forbid_if actor_attribute_matches_record(:group, :blacklisted_groups)Arguments:check - A check is a tuple of {module, keyword}.The module must implement the AshPolicyAuthorizer.Check behaviour. Generally, you won't be passing {module, opts}, but will use one of the provided functions that return that, like always() or actor_attribute_matches_record(:foo, :bar). To make custom ones define a module that implements the AshPolicyAuthorizer.Check behaviour, put a convenience function in that module that returns {module, opts}, and import that into your resource.defmodule MyResource do use Ash.Resource, authorizers: [AshPolicyAuthorizer.Authorizer] import MyCustomCheck policies do ... policy do authorize_if my_custom_check(:foo) end end endOptions:name - false A short name or description for the check, used when explaining authorization results","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidIf.html#forbid_if/2","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidIf.forbid_if/2","type":"macro"},{"doc":"","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidUnless.html","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidUnless","type":"module"},{"doc":"If the check is true, the request is forbidden, otherwise run remaining checks.Examplesforbid_unless logged_in()forbid_unless actor_attribute_matches_record(:group, :group)Arguments:check - A check is a tuple of {module, keyword}.The module must implement the AshPolicyAuthorizer.Check behaviour. Generally, you won't be passing {module, opts}, but will use one of the provided functions that return that, like always() or actor_attribute_matches_record(:foo, :bar). To make custom ones define a module that implements the AshPolicyAuthorizer.Check behaviour, put a convenience function in that module that returns {module, opts}, and import that into your resource.defmodule MyResource do use Ash.Resource, authorizers: [AshPolicyAuthorizer.Authorizer] import MyCustomCheck policies do ... policy do authorize_if my_custom_check(:foo) end end endOptions:name - false A short name or description for the check, used when explaining authorization results","ref":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidUnless.html#forbid_unless/2","title":"AshPolicyAuthorizer.Authorizer.Policy.Policies.ForbidUnless.forbid_unless/2","type":"macro"},{"doc":"A behaviour for declaring checks, which can be used to easily construct authorization rules.","ref":"AshPolicyAuthorizer.Check.html","title":"AshPolicyAuthorizer.Check","type":"behaviour"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#c:auto_filter/3","title":"AshPolicyAuthorizer.Check.auto_filter/3","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#c:check/4","title":"AshPolicyAuthorizer.Check.check/4","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#defines_auto_filter?/1","title":"AshPolicyAuthorizer.Check.defines_auto_filter?/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#defines_check?/1","title":"AshPolicyAuthorizer.Check.defines_check?/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#c:describe/1","title":"AshPolicyAuthorizer.Check.describe/1","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#c:strict_check/3","title":"AshPolicyAuthorizer.Check.strict_check/3","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#c:type/0","title":"AshPolicyAuthorizer.Check.type/0","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#t:authorizer/0","title":"AshPolicyAuthorizer.Check.authorizer/0","type":"type"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#t:check_type/0","title":"AshPolicyAuthorizer.Check.check_type/0","type":"type"},{"doc":"","ref":"AshPolicyAuthorizer.Check.html#t:options/0","title":"AshPolicyAuthorizer.Check.options/0","type":"type"},{"doc":"This check is true when the action name matches the provided action","ref":"AshPolicyAuthorizer.Check.Action.html","title":"AshPolicyAuthorizer.Check.Action","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.Action.html#strict_check/3","title":"AshPolicyAuthorizer.Check.Action.strict_check/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.Action.html#type/0","title":"AshPolicyAuthorizer.Check.Action.type/0","type":"function"},{"doc":"This check is true when the action type matches the provided type","ref":"AshPolicyAuthorizer.Check.ActionType.html","title":"AshPolicyAuthorizer.Check.ActionType","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.ActionType.html#strict_check/3","title":"AshPolicyAuthorizer.Check.ActionType.strict_check/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.ActionType.html#type/0","title":"AshPolicyAuthorizer.Check.ActionType.type/0","type":"function"},{"doc":"This check is true when the provided function over the actor returns true","ref":"AshPolicyAuthorizer.Check.ActorMatches.html","title":"AshPolicyAuthorizer.Check.ActorMatches","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.ActorMatches.html#strict_check/3","title":"AshPolicyAuthorizer.Check.ActorMatches.strict_check/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.ActorMatches.html#type/0","title":"AshPolicyAuthorizer.Check.ActorMatches.type/0","type":"function"},{"doc":"This check is true when a field on the record matches a specific filter","ref":"AshPolicyAuthorizer.Check.Attribute.html","title":"AshPolicyAuthorizer.Check.Attribute","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.auto_filter/3.","ref":"AshPolicyAuthorizer.Check.Attribute.html#auto_filter/3","title":"AshPolicyAuthorizer.Check.Attribute.auto_filter/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.check/4.","ref":"AshPolicyAuthorizer.Check.Attribute.html#check/4","title":"AshPolicyAuthorizer.Check.Attribute.check/4","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.Attribute.html#strict_check/3","title":"AshPolicyAuthorizer.Check.Attribute.strict_check/3","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.Attribute.html#strict_check_context/1","title":"AshPolicyAuthorizer.Check.Attribute.strict_check_context/1","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.Attribute.html#type/0","title":"AshPolicyAuthorizer.Check.Attribute.type/0","type":"function"},{"doc":"The global authorization checks built into ash","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html","title":"AshPolicyAuthorizer.Check.BuiltInChecks","type":"module"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#action/1","title":"AshPolicyAuthorizer.Check.BuiltInChecks.action/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#action_type/1","title":"AshPolicyAuthorizer.Check.BuiltInChecks.action_type/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#actor/1","title":"AshPolicyAuthorizer.Check.BuiltInChecks.actor/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#actor_matches/2","title":"AshPolicyAuthorizer.Check.BuiltInChecks.actor_matches/2","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#always/0","title":"AshPolicyAuthorizer.Check.BuiltInChecks.always/0","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#attribute/2","title":"AshPolicyAuthorizer.Check.BuiltInChecks.attribute/2","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#changing_attributes/1","title":"AshPolicyAuthorizer.Check.BuiltInChecks.changing_attributes/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#never/0","title":"AshPolicyAuthorizer.Check.BuiltInChecks.never/0","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.BuiltInChecks.html#relates_to_actor_via/1","title":"AshPolicyAuthorizer.Check.BuiltInChecks.relates_to_actor_via/1","type":"function"},{"doc":"This check is true when attribute changes correspond to the provided options.","ref":"AshPolicyAuthorizer.Check.ChangingAttributes.html","title":"AshPolicyAuthorizer.Check.ChangingAttributes","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.ChangingAttributes.html#strict_check/3","title":"AshPolicyAuthorizer.Check.ChangingAttributes.strict_check/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.ChangingAttributes.html#type/0","title":"AshPolicyAuthorizer.Check.ChangingAttributes.type/0","type":"function"},{"doc":"Simple equality check between a field on the actor and a field on the record","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html","title":"AshPolicyAuthorizer.Check.RelatesToActorVia","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.auto_filter/3.","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html#auto_filter/3","title":"AshPolicyAuthorizer.Check.RelatesToActorVia.auto_filter/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.check/4.","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html#check/4","title":"AshPolicyAuthorizer.Check.RelatesToActorVia.check/4","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html#strict_check/3","title":"AshPolicyAuthorizer.Check.RelatesToActorVia.strict_check/3","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html#strict_check_context/1","title":"AshPolicyAuthorizer.Check.RelatesToActorVia.strict_check_context/1","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.RelatesToActorVia.html#type/0","title":"AshPolicyAuthorizer.Check.RelatesToActorVia.type/0","type":"function"},{"doc":"This check is true when the provided result is true, and false otherwise","ref":"AshPolicyAuthorizer.Check.Static.html","title":"AshPolicyAuthorizer.Check.Static","type":"module"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.strict_check/3.","ref":"AshPolicyAuthorizer.Check.Static.html#strict_check/3","title":"AshPolicyAuthorizer.Check.Static.strict_check/3","type":"function"},{"doc":"Callback implementation for AshPolicyAuthorizer.Check.type/0.","ref":"AshPolicyAuthorizer.Check.Static.html#type/0","title":"AshPolicyAuthorizer.Check.Static.type/0","type":"function"},{"doc":"Determines if a set of authorization requests can be met or not.To read more about boolean satisfiability, see this page: https://en.wikipedia.org/wiki/Boolean_satisfiability_problem. At the end of the day, however, it is not necessary to understand exactly how Ash takes your authorization requirements and determines if a request is allowed. The important thing to understand is that Ash may or may not run any/all of your authorization rules as they may be deemed unnecessary. As such, authorization checks should have no side effects. Ideally, the checks built-in to ash should cover the bulk of your needs.","ref":"AshPolicyAuthorizer.Checker.html","title":"AshPolicyAuthorizer.Checker","type":"module"},{"doc":"","ref":"AshPolicyAuthorizer.Checker.html#find_real_scenarios/2","title":"AshPolicyAuthorizer.Checker.find_real_scenarios/2","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Checker.html#strict_check_facts/1","title":"AshPolicyAuthorizer.Checker.strict_check_facts/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.Checker.html#strict_check_scenarios/1","title":"AshPolicyAuthorizer.Checker.strict_check_scenarios/1","type":"function"},{"doc":"A type of check that is represented by a filter statementThat filter statement can be templated, currently only supporting {:_actor, field} which will replace that portion of the filter with the appropriate field value from the actor and {:_actor, :_primary_key} which will replace the value with a keyword list of the primary key fields of an actor to their values, like [id: 1]. If the actor is not present {:_actor, field} becomes nil, and {:_actor, :_primary_key} becomes false.","ref":"AshPolicyAuthorizer.FilterCheck.html","title":"AshPolicyAuthorizer.FilterCheck","type":"behaviour"},{"doc":"","ref":"AshPolicyAuthorizer.FilterCheck.html#build_filter/2","title":"AshPolicyAuthorizer.FilterCheck.build_filter/2","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.FilterCheck.html#c:filter/1","title":"AshPolicyAuthorizer.FilterCheck.filter/1","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.FilterCheck.html#is_filter_check?/1","title":"AshPolicyAuthorizer.FilterCheck.is_filter_check?/1","type":"function"},{"doc":"","ref":"AshPolicyAuthorizer.FilterCheck.html#t:options/0","title":"AshPolicyAuthorizer.FilterCheck.options/0","type":"type"},{"doc":"A type of check that operates only on request context, never on the data","ref":"AshPolicyAuthorizer.SimpleCheck.html","title":"AshPolicyAuthorizer.SimpleCheck","type":"behaviour"},{"doc":"","ref":"AshPolicyAuthorizer.SimpleCheck.html#c:match?/3","title":"AshPolicyAuthorizer.SimpleCheck.match?/3","type":"callback"},{"doc":"","ref":"AshPolicyAuthorizer.SimpleCheck.html#t:options/0","title":"AshPolicyAuthorizer.SimpleCheck.options/0","type":"type"},{"doc":"Raised when authorization for an action fails","ref":"AshPolicyAuthorizer.Forbidden.html","title":"AshPolicyAuthorizer.Forbidden","type":"exception"}]